﻿''' <summary> sowohl beim Server als auch beim Client erforderliche Infos zu RemotingChannels </summary> 
Public NotInheritable Class ServerInfo
   Private Sub New()
   End Sub
   Public Const Host As String = "localhost"
   Public Const ChannelName As String = "ChannelName"
   Public Const Port As Integer = 15000
End Class

''' <summary>
''' Definition der Kommunikation: Subs definieren, wie der Client auf den Server zugreift (Handshake, Message), die Callbacks der Handshake-Signatur definieren, wie der Server auf den Client zugreift (HandshakeSuccess, Message, MoveForm)  
''' </summary>
Public Interface IServerObject
   Sub HandShake(nick As String, callbackHandshakeSuccess As Action(Of Integer?), callbackMessage As Action(Of String), callbackMoveForm As Action(Of Integer))
   Sub Message(id As Integer, msg As String)
End Interface
