﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
Die ProxyFactory kann über einen TcpChannel ServerObject-Proxies vom Server abrufen - (theoretisch auch mehrere, und auch verschiedene Interfaces)
#End If
' -------------- Imports & Options --------------------
Imports System.Runtime.Remoting.Channels.Tcp
Imports System.Runtime.Remoting
Imports System.Collections
Imports System.Runtime.Remoting.Channels
#End Region 'FileHeader

Public Class ProxyFactory : Implements IDisposable
   Private tcpChan As TcpChannel
   Private _ServerUri As String 'eine Art ConnectionString zum Server
   Private ReadOnly _tpIServer As Type = GetType(IServerObject)

   ''' <summary> erstellt einen RemoteChannel und registriert das Remoting-Interface </summary> 
   Public Sub New()
      _ServerUri = String.Concat("tcp://", ServerInfo.Host, ":", ServerInfo.Port, "/", ServerInfo.ChannelName)
      Dim clientChannelName = "Client" + ServerInfo.ChannelName
      If ChannelServices.GetChannel(clientChannelName) IsNot Nothing Then Return
      Dim clientProv = New BinaryClientFormatterSinkProvider()
      Dim serverProv = New BinaryServerFormatterSinkProvider()
      serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full
      Dim props As New Hashtable() 'der TcpChannel-Konstruktor braucht sone bescheuerte Hashtable
      props("name") = clientChannelName
      props("port") = 0          'First available port - ist egal
      tcpChan = New TcpChannel(props, clientProv, serverProv)
      ChannelServices.RegisterChannel(tcpChan, False)
      If RemotingConfiguration.IsWellKnownClientType(_tpIServer) IsNot Nothing Then Return
      RemotingConfiguration.RegisterWellKnownClientType(_tpIServer, _ServerUri) 'sonst failt der Activator bei GetProxy()
   End Sub

   Public Function GetProxy() As IServerObject
      'ruft durch den Channel vom Server eine konkrete IServerObject-Instanz ab 
      Return DirectCast(Activator.GetObject(_tpIServer, _ServerUri), IServerObject)
   End Function

   ''' <summary>
   ''' komischerweise bleibt trotzdem der Proxy intakt - mir ist keine Möglichkeit bekannt, den Channel wirklich zu schließen
   ''' </summary>
   Public Overridable Sub Dispose(isDisposing As Boolean)
      If IsDisposed Then Return
      ChannelServices.UnregisterChannel(tcpChan)
      tcpChan = Nothing
   End Sub
   Public ReadOnly Property IsDisposed() As Boolean
      Get
         Return tcpChan Is Nothing
      End Get
   End Property
   Public Sub Dispose() Implements IDisposable.Dispose
      Dispose(True)
   End Sub
End Class
