﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
abstrakte Basisklasse, die von einer Klasse im Server zu beerben ist: kümmert sich um das Channel-Zeugs und um Resourcenbereinigung (sollte jedenfalls)
#End If
' -------------- Imports & Options --------------------
Imports System.Runtime.Remoting.Channels.Tcp
Imports System.Runtime.Remoting
Imports System.Collections
Imports System.Runtime.Remoting.Channels
#End Region 'FileHeader

Public MustInherit Class ServerBase : Inherits MarshalByRefObject : Implements IDisposable
   Private _ServerChannel As TcpServerChannel
   Private _ChannelRef As ObjRef
   Public Sub New()
      'komisches Zeugs halt
      Dim props As New Hashtable() 'der TcpChannel-Konstruktor braucht sone bescheuerte Hashtable
      props("port") = ServerInfo.Port
      props("name") = ServerInfo.ChannelName
      Dim serverProv As New BinaryServerFormatterSinkProvider()
      serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full
      _ServerChannel = New TcpServerChannel(props, serverProv)
      ChannelServices.RegisterChannel(_ServerChannel, False)
      _ChannelRef = RemotingServices.Marshal(Me, _ServerChannel.ChannelName) 'keine Ahnung, was das macht - ist aber erforderlich
   End Sub
   ''' <summary>
   ''' in dieser Form unsinnig, aber verdeutlicht das Remoting-LifeTime-Problem: Beim langlaufenden Server sammeln normalerweise sich "tote Clients" an. 
   ''' MarshalByRefObject ist iwie eine Automation des IsAlive-Pings, und wie da gepingt wird, steuert das ILease-Objekt
   ''' </summary>
   Public Overrides Function InitializeLifetimeService() As Object
      Dim Lease = DirectCast(MyBase.InitializeLifetimeService(), Lifetime.ILease)
      Return Lease
   End Function
   Public Overridable Sub Dispose(isDisposing As Boolean)
      If IsDisposed Then Return
      RemotingServices.Unmarshal(_ChannelRef)
      ChannelServices.UnregisterChannel(_ServerChannel)
      _ServerChannel = Nothing
      _ChannelRef = Nothing
   End Sub
   Public ReadOnly Property IsDisposed() As Boolean
      Get
         Return _ServerChannel Is Nothing
      End Get
   End Property
   Public Sub Dispose() Implements IDisposable.Dispose
      Dispose(True)
   End Sub
End Class
