﻿Imports System.Runtime.CompilerServices

Namespace System.Windows.Forms

   ''' <summary>
   ''' Stellt Methoden bereit, mit denen ein beliebiger Methoden-Aufruf mit bis zu 3 Argumenten
   ''' in einen Nebenthread verlegt werden kann, bzw. aus einem Nebenthread in den Hauptthread
   ''' </summary>
   Public Module CrossThreadX

      <Extension()> _
      Public Sub RunAsync(Of T1, T2, T3)( _
            ByVal Action As Action(Of T1, T2, T3), _
            ByVal Arg1 As T1, ByVal Arg2 As T2, ByVal Arg3 As T3)
         ' Aufruf von Action.EndInvoke() gewährleisten, indem er als Callback-Argument mitgegeben wird
         Action.BeginInvoke(Arg1, Arg2, Arg3, AddressOf Action.EndInvoke, Nothing)
      End Sub
      <Extension()> _
      Public Sub RunAsync(Of T1, T2)( _
            ByVal Action As Action(Of T1, T2), ByVal Arg1 As T1, ByVal Arg2 As T2)
         Action.BeginInvoke(Arg1, Arg2, AddressOf Action.EndInvoke, Nothing)
      End Sub
      <Extension()> _
      Public Sub RunAsync(Of T1)(ByVal Action As Action(Of T1), ByVal Arg1 As T1)
         Action.BeginInvoke(Arg1, AddressOf Action.EndInvoke, Nothing)
      End Sub
      <Extension()> _
      Public Sub RunAsync(ByVal Action As Action)
         Action.BeginInvoke(AddressOf Action.EndInvoke, Nothing)
      End Sub

      Private Function GuiCrossInvoke( _
            ByVal Action As [Delegate], ByVal ParamArray Args() As Object) As Boolean
         If Application.OpenForms.Count = 0 Then
            'wenn kein Form mehr da ist, so tun, als ob das Invoking ausgeführt wäre
            Return True
         End If
         If Application.OpenForms(0).InvokeRequired Then
            Application.OpenForms(0).BeginInvoke(Action, Args)
            Return True
         End If
      End Function

      <Extension()> _
      Public Sub RunGui(Of T1, T2, T3)( _
            ByVal Action As Action(Of T1, T2, T3), _
            ByVal Arg1 As T1, ByVal Arg2 As T2, ByVal Arg3 As T3)
         If Not GuiCrossInvoke(Action, Arg1, Arg2, Arg3) Then Action(Arg1, Arg2, Arg3)
      End Sub
      <Extension()> _
      Public Sub RunGui(Of T1, T2)( _
            ByVal Action As Action(Of T1, T2), ByVal Arg1 As T1, ByVal Arg2 As T2)
         If Not GuiCrossInvoke(Action, Arg1, Arg2) Then Action(Arg1, Arg2)
      End Sub
      <Extension()> _
      Public Sub RunGui(Of T1)(ByVal Action As Action(Of T1), ByVal Arg1 As T1)
         If Not GuiCrossInvoke(Action, Arg1) Then Action(Arg1)
      End Sub
      <Extension()> _
      Public Sub RunGui(ByVal Action As Action)
         If Not GuiCrossInvoke(Action) Then Action()
      End Sub

   End Module

End Namespace