﻿Option Compare Text

Imports Microsoft.VisualBasic.ControlChars
Imports System.Runtime.CompilerServices
Imports System.Text
Imports System.Collections
Imports System.Text.RegularExpressions
Imports System.Globalization

Namespace System

   Public Module StringX

      '''<summary> interpretiert alle \n am Anfang als newline</summary>
      Private Function ReplaceBackslashN(ByVal s As String) As StringBuilder
         With New StringBuilder
            For i = 0 To s.Length - 2 Step 2
               If s.IndexOf("\n", i, 2) < 0 Then Exit For
               .Append(CrLf)
            Next
            Return .Append(s.Substring(.Length))
         End With
      End Function

      '''<summary> verkettet alles, interpretiert alle \n am Anfang als newline</summary>
      <Extension()> _
      Public Function And2(ByVal Subj As String, ByVal ParamArray others() As Object) As String
         Dim sb = ReplaceBackslashN(Subj)
         For Each itm In others
            sb.Append(ReplaceBackslashN(itm.ToString).ToString)
         Next
         Return sb.ToString
      End Function

      '''<summary> verkettet alles</summary>
      <Extension()> _
      Public Function [And](ByVal Subj As String, ByVal ParamArray others() As Object) As String
         Return String.Concat(Subj, String.Concat(others))
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function Between(ByVal Delimiter As Char, ByVal ParamArray Args() As Object) As String
         Return Args.Join(Delimiter)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function Between(ByVal Delimiter As Char, ByVal Args As IEnumerable) As String
         Return Args.Join(Delimiter)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function Between(ByVal Delimiter As String, ByVal ParamArray Args() As Object) As String
         Return Args.Join(Delimiter)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function Between(ByVal Delimiter As String, ByVal Args As IEnumerable) As String
         Return Args.Join(Delimiter)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Private Function Join(ByVal Subj As IEnumerable, ByVal Delimiter As String) As String
         Dim _SB As New System.Text.StringBuilder
         With Subj.GetEnumerator
            If .MoveNext Then
               _SB.Append(If(.Current, "").ToString)
               While .MoveNext
                  _SB.Append(Delimiter).Append(If(.Current, "").ToString)
               End While
            End If
         End With
         Return _SB.ToString
      End Function

   End Module


End Namespace