﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
der Server guckt, ob der beim Handshake übergebenen Nick bereits belegt ist, und antwortet entsprechend. Bei Success wird ein Datensatz angelegt, wo zum Nick auch die Callbacks gebunkert werden. Die Id wird dann zurückgeschickt - oder Nothing (deswegen Nullable(Of Integer))
Eingehende Messages werden in die Senden-Textbox gelegt. Weitergeleitet werden sie erst durch DGV-CellClick - dieses um zu demonstrieren, dass der Server die volle Kontrolle hat, von wem er was an wen schickt.
Beachte auch den MoveForm-Callback: Remoting ist nicht nur Text verschicken, sondern tatsächliches Methoden-Aufrufen auf der anneren Seite. Damit ist ein BefehlsProtokoll obsolet, denn es ist quasi durch das Interface definiert.
#End If
' -------------- Imports & Options --------------------
Imports Server.ServerDts
#End Region 'FileHeader

Public Class frmServer
   Public Event MoreClient As EventHandler
   Private WithEvents _Server As ServerObject

   Private Sub ckOnline_CheckedChanged(sender As Object, e As EventArgs) Handles ckOnline.CheckedChanged
      If ckOnline.Checked Then
         _Server = New ServerObject
         txtLog.AppendLine("gone online")
      Else
         _Server.Dispose()
         _Server = Nothing
      End If
   End Sub

   Private Sub _Server_HandShakeIn(nick As String, callbackHandshake As Action(Of Integer?), callbackMessage As Action(Of String), callbackMoveForm As Action(Of Integer)) Handles _Server.HandShakeIn
      Dim rwClient = ServerDts.Client.All.FirstOrDefault(Function(rw) rw.Nick = nick)
      If rwClient.NotNull Then
         callbackHandshake(Nothing)
         txtLog.AppendLine("nick '", nick, "' rejected")
      Else
         rwClient = ServerDts.Client.AddClientRow(nick)
         callbackHandshake(rwClient.ID)
         rwClient.MessageCallback = callbackMessage
         rwClient.MoveFormCallback = callbackMoveForm
         txtLog.AppendLine("nick '", nick, "' accepted")
      End If
   End Sub

   Private Sub _Server_MessageIn(id As Integer, msg As String) Handles _Server.MessageIn
      Dim rwClient = ServerDts.Client.FindByID(id)
      CrossThreadX.RunGui(Sub()
                             Dim txt = rwClient.Nick.And(": ", msg)
                             txtToSend.Text = txt
                             txtLog.AppendLine(txt)
                          End Sub)
   End Sub

   Private Sub ClientDataGridView_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles ClientDataGridView.CellContentClick
      Dim rwClient = ClientDataGridView.DataRow(Of ClientRow)(e.RowIndex)
      Dim clm = ClientDataGridView.Columns(e.ColumnIndex)
      Select Case True
         Case clm Is clmBtSend
            CrossThreadX.RunAsync(rwClient.MessageCallback, txtToSend.Text)
         Case clm Is clmBtDown
            CrossThreadX.RunAsync(rwClient.MoveFormCallback, 50)
         Case clm Is clmBtUp
            CrossThreadX.RunAsync(rwClient.MoveFormCallback, -50)
      End Select
   End Sub

   'zum Testen Bereitstellung weiterer Clients anfordern
   Private Sub btMoreClients_Click(sender As System.Object, e As System.EventArgs) Handles btMoreClients.Click
      RaiseEvent MoreClient(Me, EventArgs.Empty)
   End Sub
End Class
